Subject: Re: git branch doesn't allow me to forcibly delete branch which was checked out in a now-deleted worktree dir

From: Erik Johnson <[email-masked]>
Date: Sat, 9 Jul 2016 00:05:00 -0500

On Fri, Jul 08, 2016 at 09:58:26PM -0700, Jacob Keller wrote:
>On Fri, Jul 8, 2016 at 7:22 PM, Erik Johnson <[email-masked]> wrote:
>> On Fri, Jul 08, 2016 at 05:41:17PM -0700, Jacob Keller wrote:
>>> It is possible we should update "git branch -d" should perform a
>>> worktree prune first, since that would enable it to determine that you
>>> deleted the directory, and any worktree which is removable should be
>>> marked as persistent.
>>>
>>> Given that there is a known workaround (git worktree prune) and that
>>> it is expected behavior for a branch checked out to prevent deletion,
>>> I think the best coarse of action would be to patch git branch -d to
>>> do a prune before attempting to delete.
>>>
>>> Thanks,
>>> Jake
>>
>>
>> Well, I never mentioned -d (I was using -D), but I think we're both in
>> agreement.
>>
>>
>
>Out of curiosity, what is git branch -D behavior when the worktree does exist?
>
>Thanks,
>Jake

It works the same irrespective of whether or not the directory exists:

% git worktree add ../foo
Preparing ../foo (identifier foo)
HEAD is now at 91e095b Merge pull request #34429 from terminalmage/pkg-latest-versioncheck
% git branch -D foo
error: Cannot delete branch 'foo' checked out at '/home/erik/git/salt/foo'
% rm -rf /home/erik/git/salt/foo
% git branch -D foo
error: Cannot delete branch 'foo' checked out at '/home/erik/git/salt/foo'
% git worktree prune -v
Removing worktrees/foo: gitdir file points to non-existent location
% git branch -D foo
Deleted branch foo (was 91e095b).

--

-Erik

"For me, it is far better to grasp the universe as it really is than to
persist in delusion, however satisfying and reassuring."  --Carl Sagan